<template>
  <b-modal
    id="templateStartModal"
    :model-value="open"
    hide-footer
    @hidden="close"
  >
    <template #title>
      <span class="h6">{{
        $t(`page.settings.template.start.modal.title`)
      }}</span>
    </template>

    <!-- Body -->
    <i18n-t
      scope="global"
      :keypath="`page.settings.template.start.modal.body`"
      tag="p"
      class="mb-2"
    >
      <template #br><br /></template>
    </i18n-t>

    <!-- Styled -->
    <b-form-file
      id="templateFileButton"
      ref="templateFileButton"
      v-model="file"
      class="mb-3"
      :state="file !== null ? true : null"
      :placeholder="$t('page.settings.template.start.modal.placeholder')"
      :drop-placeholder="
        $t('page.settings.template.start.modal.dropPlaceholder')
      "
    ></b-form-file>

    <!-- Modal Cancel Button -->
    <b-button @click="close">{{ $t("buttons.cancel") }}</b-button>
    <!-- Modal Next Button -->
    <b-button
      id="nextFromStart"
      ref="nextFromStart"
      variant="primary"
      class="float-end"
      :disabled="!Boolean(file)"
      @click="next"
    >
      {{ $t(`buttons.next`) }}
    </b-button>
  </b-modal>
</template>

<script lang="ts">
import type { ResourceForUpdateDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  name: "TemplateStartModal",
  props: {
    resourceForm: {
      type: Object as PropType<ResourceForUpdateDto>,
      required: true,
    },
    open: {
      type: Boolean,
      required: true,
    },
  },

  emits: {
    close: () => true,
    next: (_: File) => true,
  },

  data() {
    return {
      file: null as File | null,
    };
  },

  watch: {
    open() {
      this.file = null;
    },
  },

  methods: {
    close() {
      this.$emit("close");
    },
    next() {
      if (this.file) {
        this.$emit("next", this.file);
      }
    },
  },
});
</script>
